/*  $Id: zip_digital_signature.cpp,v 1.4 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "zip_digital_signature.h"
#include "API/Core/IOData/inputsource.h"
#include "API/Core/IOData/outputsource.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_DigitalSignature construction:

CL_Zip_DigitalSignature::CL_Zip_DigitalSignature()
{
	signature = 0x05054b50;
}

CL_Zip_DigitalSignature::~CL_Zip_DigitalSignature()
{
}
	
/////////////////////////////////////////////////////////////////////////////
// CL_Zip_DigitalSignature attributes:

	
/////////////////////////////////////////////////////////////////////////////
// CL_Zip_DigitalSignature operations:

void CL_Zip_DigitalSignature::load(CL_InputSource *input)
{
	signature = input->read_int32();
	if (signature != 0x05054b50)
	{
		throw CL_Error("Incorrect Digital Signature signature!");
	}

	size_of_data = input->read_short16();

	char *str = new char[size_of_data];
	try
	{
		input->read(str, size_of_data);
		signature_data = std::string(str, size_of_data);

		delete[] str;
	}
	catch (...)
	{
		delete[] str;
	}
}
	
void CL_Zip_DigitalSignature::save(CL_OutputSource *output)
{
	output->write_int32(signature);
	output->write_short16(size_of_data);
	output->write(signature_data.data(), size_of_data);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_DigitalSignature implementation:
